/////////////////////////////////////////////////////////////////////////////////////////////////////////
//                       		КЛОЧКОВ ПАВЕЛ
//			       http://www.interestprograms.ru
/////////////////////////////////////////////////////////////////////////////////////////////////////////


// TectCFDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TectCF.h"
#include "TectCFDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTectCFDlg dialog

// init GDIPLus
//GdiplusStartupInput gdiplusStartupInput;
//ULONG_PTR           gdiplusToken;


CTectCFDlg::CTectCFDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTectCFDlg::IDD, pParent)
	, m_pPicture(NULL)
	, m_pStream(NULL)
{
	//{{AFX_DATA_INIT(CTectCFDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);


}

//CTestCFDlg::~CTestCFDlg()
//{
	//GdiplusShutdown(gdiplusToken);
//}

void CTectCFDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTectCFDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTectCFDlg, CDialog)
	//{{AFX_MSG_MAP(CTectCFDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTectCFDlg message handlers

BOOL CTectCFDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTectCFDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTectCFDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);

		RECT rc;

		if(m_pStream != NULL)
		{
			// прорисовка изображения с помощью GDI
			GetDlgItem(IDC_STATIC_GDI)->GetClientRect(&rc);
			CDC* pDC = GetDlgItem(IDC_STATIC_GDI)->GetDC();
			DrawImage( pDC->GetSafeHdc(), rc);
			GetDlgItem(IDC_STATIC_GDI)->ReleaseDC(pDC);
		}

		//CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTectCFDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTectCFDlg::OnButton1() 
{
	// счетчик потоков (одновременно их имя)
	static numberstream = 0;

	// можете в составной файл добавлять любое количество потоков картинок и текста
	// эта переменная будет следить когда переключаться на начало просмотра
	bool again = true;

	IStorage* pStorage    = NULL;
	IStorage* psubStorage = NULL;
	IStream* pStream      = NULL;

	CString pathmain = "test", namestream;
	namestream.Format("%d", numberstream );

	HRESULT hr = StgOpenStorage( pathmain.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0,0, &pStorage);
	if(hr == S_OK){
		// открываем потоки картинок
		hr = pStorage->OpenStream(namestream.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, &pStream);
		if(hr == S_OK){
			STATSTG statstg;
			hr = pStream->Stat(&statstg, STATFLAG_NONAME);
			if(hr == S_OK){
				HGLOBAL hMem  = GlobalAlloc( GHND, (unsigned long)statstg.cbSize.QuadPart);
				if(hMem != NULL){
					LPVOID memory = GlobalLock(hMem);
					pStream->Read(memory, (unsigned long)statstg.cbSize.QuadPart, 0);
					GlobalUnlock(hMem);
					hr = CreateStreamOnHGlobal(hMem, FALSE, &m_pStream);
					if(hr == S_OK){
						// для использования "обычного "GDI
						LoadImageFromStream(m_pStream);
						again = false;
						numberstream++;
					}

				}// if(hMem != NULL){
			}
			if(pStream != NULL){
				pStream->Release();
				pStream = NULL;
			}
			// открываем текстовые потоки
			CString namesubstorage = "text";
			hr = pStorage->OpenStorage(namesubstorage.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, 0, &psubStorage); 
			if(hr == S_OK){
				hr = psubStorage->OpenStream(namestream.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, &pStream);
				if(hr == S_OK){
					STATSTG statstg;
					hr = pStream->Stat(&statstg, STATFLAG_NONAME);
					if(hr == S_OK){
						HGLOBAL hMem  = GlobalAlloc( GHND, (unsigned long)statstg.cbSize.QuadPart);
						if(hMem != NULL){
							TCHAR* pTCHAR = new TCHAR[(int)statstg.cbSize.QuadPart+1];
							if(pTCHAR != NULL){
								LPVOID memory = GlobalLock(hMem);
								hr =pStream->Read(memory, (unsigned long)statstg.cbSize.QuadPart, 0);
								if(hr == S_OK){
									CopyMemory(pTCHAR, memory, (UINT)statstg.cbSize.QuadPart);
									pTCHAR[statstg.cbSize.QuadPart] = '\0';
									GlobalUnlock(hMem);
									GlobalFree(hMem);
									GetDlgItem(IDC_STATIC_TEXT)->SetWindowText(pTCHAR);
									delete pTCHAR;
								}
							}
						}
					}
					if(pStream != NULL){
						pStream->Release();
						pStream = NULL;
					}
				}// if(hr == S_OK){ hr = psubStorage->OpenStream(namestre 
			}// if(hr == S_OK){ hr = pStorage->OpenStorage(namesu
		//----------------------------------------------------------------------------------------
			{
			// открываем звуковые потоки
			CString namesubstorage = "звук";
			hr = pStorage->OpenStorage(namesubstorage.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, 0, &psubStorage); 
			if(hr == S_OK){
				hr = psubStorage->OpenStream(namestream.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, &pStream);
				if(hr == S_OK){
					STATSTG statstg;
					hr = pStream->Stat(&statstg, STATFLAG_NONAME);
					if(hr == S_OK){
						HGLOBAL hMem  = GlobalAlloc( GHND, (unsigned long)statstg.cbSize.QuadPart);
						if(hMem != NULL){
								LPVOID memory = GlobalLock(hMem);
								hr =pStream->Read(memory, (unsigned long)statstg.cbSize.QuadPart, 0);
								if(hr == S_OK){
									PlaySound( (LPCTSTR)memory, NULL, SND_MEMORY|SND_ASYNC);
									GlobalUnlock(hMem);
									//GlobalFree(hMem);
							
							}
						}
					}
					if(pStream != NULL){
						pStream->Release();
						pStream = NULL;
					}
				}// if(hr == S_OK){ hr = psubStorage->OpenStream(namestre 
			}// if(hr == S_OK){ hr = pStorage->OpenStorage(namesu
			}
		//------------------------------------------------------------------------------------------
		}
		if(pStorage != NULL)
			pStorage->Release();
	}
	else{
		AfxMessageBox("Файл \"test\" отсутствует или поврежден!\nНа www.interestprograms.ru  вы найдете действующий пример.");
		//MessageBox("Файл \"test\" отсутствует или поврежден!\nНа www.interestprograms.ru  вы найдете действующий пример.");
	}

	if(again == true)
		numberstream = 0;

	

	CRect rc;
	rc.SetRect(0,0,1,1);
	InvalidateRect(&rc);
	
}

HRESULT CTectCFDlg::LoadImageFromStream(IStream* pStream)
{
	HRESULT hr = E_NOTIMPL;
	hr = ::OleLoadPicture(pStream, 0, TRUE, IID_IPicture, (void**)&m_pPicture);

	return hr;

}

HRESULT CTectCFDlg::DrawImage(HDC hdc, const RECT& rc)
{
	HRESULT hr = E_UNEXPECTED;
	if (m_pPicture != NULL){
		// получаем ширину и высоту изображения
		long hmWidth = 0, hmHeight = 0;
		m_pPicture->get_Width(&hmWidth);
		m_pPicture->get_Height(&hmHeight);

		hr = m_pPicture->Render(
			hdc,					// контекст в котором будем рисовать
			rc.left,				// координата left рисуемого изображения в контесте
			rc.top,					// координата top  рисуемого изображения в контесте
			rc.right  - rc.left,	// ширина рисуемого изображения
			rc.bottom - rc.top,		// высота рисуемого изображения
			0,						// горизонтальное смещение исходного изображения
			hmHeight,				// вертикальное смещение исходного изображения
			hmWidth,		        // сжатие и растяжение в горизонтальном измерении
			-hmHeight,				// сжатие и растяжение в вертикальном измерении		
			NULL	/*&rc*/		    // прямоугольник раположения изображения если hdc принадлежит метафайлу
			);
	}

	return hr;
}
